# Command history

Commands were run in the order listed below on a debian based system.

## Initial setup

- Initialize go module
  ```bash
  go mod init somepi.ddns.net/gitea/gilex-dev/YetAnotherToDoList
  ```
- Install cobra-cli (try `~/go/bin/cobra-cli` if `cobra-cli` can not be found in your `PATH`)

  ```bash
  go install github.com/spf13/cobra-cli@latest
  cobra-cli init --viper --license gpl-3.0 --author "gilex-dev gilex-dev@proton.me"
  ```

- Add missing modules
  ```bash
  go mod tidy
  ```
- Add license command
  ```bash
  cobra-cli add license
  ```
- Add qglgen

```bash
printf '// +build tools\npackage tools\nimport (_ "github.com/99designs/gqlgen"\n _ "github.com/99designs/gqlgen/graphql/introspection")' | gofmt > tools.go
go mod tidy
go run github.com/99designs/gqlgen init --server server/main.go
go mod tidy
```
